searchData={"items":[{"type":"task","title":"mix spaceboy.gen.cert","doc":"Generates self-signed certificate for localhost and saves it at `priv/ssl/`\n\nBy default uses EC `prime256v1` as it is the most widely supported EC algorithm.\nBut once support for `ED25519` curve will grow I will switch it to this one\nfor security reasons and to promote good practices. If you want to use ED25519\neven now you can use `--ed25519` option in this task.\n\nWhen first used it copies default `openssl.cnf` to your `priv/ssl/` directory\nand generates self-signed certificate for `localhost` and `127.0.0.1`. If you\nwant certificate for different hosts and IPs you can edit the generated\n`priv/ssl/openssl.cnf` file manually, generate new certificate and it will use\nthose values instead.","ref":"Mix.Tasks.Spaceboy.Gen.Cert.html"},{"type":"task","title":"Options - mix spaceboy.gen.cert","doc":"You can specify how many days certificate should be valid. Default is 365 days\nbut you can specify different one (e.g. 100 years):\n\n    mix spaceboy.gen.cert --days 36500\n\nYou can specify to generate private key with ED25519 algorithm:\n\n    mix spaceboy.gen.cert --ed25519","ref":"Mix.Tasks.Spaceboy.Gen.Cert.html#module-options"},{"type":"task","title":"Dependencies - mix spaceboy.gen.cert","doc":"This mix task is calling `openssl` program so you need to have it installed and\nin path.","ref":"Mix.Tasks.Spaceboy.Gen.Cert.html#module-dependencies"},{"type":"task","title":"mix spaceboy.server","doc":"Starts the configured Gemini server","ref":"Mix.Tasks.Spaceboy.Server.html"},{"type":"task","title":"Command line options - mix spaceboy.server","doc":"This task accepts the same command-line arguments as `run`. For additional\ninformation, refer to the documentation for `Mix.Tasks.Run`.\n\nFor example, to run `spaceboy.server` without recompiling:\n\n    mix spaceboy.server --no-compile\n\nThe `--no-halt` flag is automatically added.","ref":"Mix.Tasks.Spaceboy.Server.html#module-command-line-options"},{"type":"module","title":"Spaceboy.Conn.Unfetched","doc":"A struct used as default on unfetched fields.","ref":"Spaceboy.Conn.Unfetched.html"},{"type":"type","title":"Spaceboy.Conn.Unfetched.t/0","doc":"A struct used as default on unfetched fields.\n\nThe `:aspect` key of the struct specifies what field is still unfetched.","ref":"Spaceboy.Conn.Unfetched.html#t:t/0"},{"type":"module","title":"Spaceboy.Conn","doc":"Struct representing Spaceboy connection (request) roughly equivalent to\n`Plug.Conn`\n\nThis is main struct that will go through the whole request lifetime.","ref":"Spaceboy.Conn.html"},{"type":"module","title":"Request fields - Spaceboy.Conn","doc":"These values are set by the framework and you are supposed to treat them as\nread-only.\n\n  * `:scheme` - is always `:gemini` (no other schemes are supported)\n  * `:host` - will be set to host from request\n  * `:port` - listening port (default 1965)\n  * `:remote_ip` - IP address of the client (or closest proxy)\n  * `:path_info` - path segments\n  * `:request_path` - default path as received from client\n  * `:query_string` - query string as received from client\n  * `:peer_cert` - client certificate","ref":"Spaceboy.Conn.html#module-request-fields"},{"type":"module","title":"Fetchable fields - Spaceboy.Conn","doc":"These fields are not populated until they are fetched manually.\n\n  * `:request_id` - unique ID, populated by `Spaceboy.Middleware.RequestId`\n    middleware\n  * `:path_params` - fetched by `Spaceboy.Router`\n  * `:query_params` - fetched by `fetch_query_params/1`\n  * `:params` - combined field of `:path_params` and `:query_params`\n\nThose fields requires manual fetching because you don't always want to format\ne.g. query. If you are using query for simple user input (e.g. username) and\nthe query looks like `?my_username` you actually don't want to fetch it and\ncreate params from it because they would look like: `%{\"my_username\" => \"\"}`","ref":"Spaceboy.Conn.html#module-fetchable-fields"},{"type":"module","title":"Response fields - Spaceboy.Conn","doc":"You are supposed to set those values during request lifetime with the functions\nin this module:\n\n  * `:header` - header struct for the response\n  * `:body` - response body or file path\n\nFurthermore, the `:before_send` field stores callbacks that are invoked before\nthe connection is sent.","ref":"Spaceboy.Conn.html#module-response-fields"},{"type":"module","title":"Connection fields - Spaceboy.Conn","doc":"* `:assigns` - user data\n  * `:halted` - the boolean status on whether the pipeline was halted\n  * `:state` - the connection state\n  * `:owner` - process which owns the connection\n\nThe connection state is used to track the connection lifecycle. It starts as\n`:unset` but is changed to `:set` or `:set_file` when response is set. Its\nfinal result is `:sent`.","ref":"Spaceboy.Conn.html#module-connection-fields"},{"type":"function","title":"Spaceboy.Conn.assign/3","doc":"Assigns a value to a key in the connection","ref":"Spaceboy.Conn.html#assign/3"},{"type":"function","title":"Spaceboy.Conn.fetch_query_params/1","doc":"Fetch query params - decode `:query_string` to `t:map()`","ref":"Spaceboy.Conn.html#fetch_query_params/1"},{"type":"function","title":"Spaceboy.Conn.file/3","doc":"Set file as response.\n\nThird argument is MIME type of the file. If it is not set the function will use\n`MIME.from_path/1` function to guess its type.","ref":"Spaceboy.Conn.html#file/3"},{"type":"function","title":"Spaceboy.Conn.merge_assigns/2","doc":"Assigns multiple values to keys in the connection.\n\nEquivalent to multiple calls to `assign/3`","ref":"Spaceboy.Conn.html#merge_assigns/2"},{"type":"function","title":"Spaceboy.Conn.register_before_send/2","doc":"Add function to be run right before the response is actually send.\n\nMultiple functions will get executed in LIFO order.","ref":"Spaceboy.Conn.html#register_before_send/2"},{"type":"function","title":"Spaceboy.Conn.resp/3","doc":"Set response header and potentially body to the function.","ref":"Spaceboy.Conn.html#resp/3"},{"type":"type","title":"Spaceboy.Conn.state/0","doc":"","ref":"Spaceboy.Conn.html#t:state/0"},{"type":"type","title":"Spaceboy.Conn.t/0","doc":"Connection struct which holds all the data related to Gemini connection","ref":"Spaceboy.Conn.html#t:t/0"},{"type":"module","title":"Spaceboy.Controller","doc":"Controllers group common functionality and are pointed to by routers.\n\nSpaceboy controllers are very similar to Phoenix ones, but unlike Phoenix\nthere is no concept of a separate \"view\" module.\n\nControllers are related to Connections, and any module that `use`s this one\nautomatically imports `Spaceboy.Conn`.","ref":"Spaceboy.Controller.html"},{"type":"module","title":"Options - Spaceboy.Controller","doc":"* `:root` the directory containing templates that can be used with `render`.\n    Defaults to `lib/templates/`, same as Phoenix. It is always relative to\n    your application root folder.","ref":"Spaceboy.Controller.html#module-options"},{"type":"function","title":"Spaceboy.Controller.auth_required/2","doc":"Set client certificate required response","ref":"Spaceboy.Controller.html#auth_required/2"},{"type":"function","title":"Spaceboy.Controller.gemini/2","doc":"Set text/gemini string as response","ref":"Spaceboy.Controller.html#gemini/2"},{"type":"function","title":"Spaceboy.Controller.input/2","doc":"Set input response","ref":"Spaceboy.Controller.html#input/2"},{"type":"function","title":"Spaceboy.Controller.json/2","doc":"Set map as JSON response","ref":"Spaceboy.Controller.html#json/2"},{"type":"function","title":"Spaceboy.Controller.not_found/2","doc":"Set not found response","ref":"Spaceboy.Controller.html#not_found/2"},{"type":"function","title":"Spaceboy.Controller.redirect/2","doc":"Set redirect response","ref":"Spaceboy.Controller.html#redirect/2"},{"type":"function","title":"Spaceboy.Controller.render/3","doc":"Set response as rendered template","ref":"Spaceboy.Controller.html#render/3"},{"type":"function","title":"Spaceboy.Controller.text/2","doc":"Set text/plain string as response","ref":"Spaceboy.Controller.html#text/2"},{"type":"module","title":"Spaceboy.Router","doc":"Router implementation for Spaceboy server.\n\nRouter is technically a `Spaceboy.Middleware` but it is so heavily customized\nthat you would not recognize it. But of course you don't have to use this\nhelper module and implement it from scratch as `Spaceboy.Middleware`.\n\n`Spaceboy.Router` is usually last middleware in your `Spaceboy.Server` but it\nis not requirement.","ref":"Spaceboy.Router.html"},{"type":"macro","title":"Spaceboy.Router.redirect/2","doc":"Adds redirect","ref":"Spaceboy.Router.html#redirect/2"},{"type":"macro","title":"Spaceboy.Router.robots/1","doc":"Render /robots.txt file","ref":"Spaceboy.Router.html#robots/1"},{"type":"macro","title":"Options - Spaceboy.Router.robots/1","doc":"List of paths which should be disallowed for robots to crawl","ref":"Spaceboy.Router.html#robots/1-options"},{"type":"macro","title":"Spaceboy.Router.route/3","doc":"Adds route for URL","ref":"Spaceboy.Router.html#route/3"},{"type":"macro","title":"Spaceboy.Router.static/3","doc":"Render static files route","ref":"Spaceboy.Router.html#static/3"},{"type":"macro","title":"Options - Spaceboy.Router.static/3","doc":"See `Spaceboy.Static.render/2` for options (`:root` and `:prefix` are populated\nautomatically ;) )","ref":"Spaceboy.Router.html#static/3-options"},{"type":"module","title":"Spaceboy.Server","doc":"Main configuration for your Spaceboy server. Roughly equivalent to\n`Phoenix.Endpoint`","ref":"Spaceboy.Server.html"},{"type":"module","title":"TLS certificate and configuration - Spaceboy.Server","doc":"Server requires TLS certificate to function properly. It can be self-signed and\nyou can generate one with this command:\n\n```\nmix spaceboy.gen.cert\n```\n\nThe default location for certificate is: `priv/ssl/` but you can change it to\nwhatever path you want via configuration:\n\n```elixir\nconfig :example, Example.Server,\n  port: 1965,\n  allowed_hosts: [],\n  certfile: \"priv/ssl/cert.pem\",\n  keyfile: \"priv/ssl/key.pem\"\n```\n\nor when starting your server in Application module (in case you need\nprogrammatically controlled configuration):\n\n```elixir\ndef start(_type, _args) do\n  config = [\n    port: 1965,\n    allowed_hosts: [],\n    certfile: \"priv/ssl/cert.pem\",\n    keyfile: \"priv/ssl/key.pem\"\n  ]\n\n  children = [\n    {Example.Server, config}\n  ]\n\n  Supervisor.start_link(children, strategy: :one_for_one, name: Example.Supervisor)\nend\n```","ref":"Spaceboy.Server.html#module-tls-certificate-and-configuration"},{"type":"module","title":"Other options - Spaceboy.Server","doc":"* `:port` port on which the server listens on.\n  * `:allowed_hosts` this option dictates which hosts the server considers\n    valid. By default it is empty list which means the check is skipped and any\n    host is considered valid but if you want to limit which hosts are allowed\n    you do that here.","ref":"Spaceboy.Server.html#module-other-options"},{"type":"module","title":"Gemini MIME type - Spaceboy.Server","doc":"To save yourself from always passing Gemini mime type when sending file it is\nrecommended to add Gemini mime type to `MIME` library configuration:\n\n```elixir\nconfig :mime, :types, %{\n  \"text/gemini\" => [\"gmi\", \"gemini\"]\n}\n```\n\nand you need to recompile `MIME` library: `mix deps.clean mime --build`","ref":"Spaceboy.Server.html#module-gemini-mime-type"},{"type":"macro","title":"Spaceboy.Server.middleware/2","doc":"Add middleware to your server configuration","ref":"Spaceboy.Server.html#middleware/2"},{"type":"behaviour","title":"Spaceboy.Middleware","doc":"Spaceboy server middleware, roughly similar to `Plug`s plug\n\nMiddleware has to implement two functions `c:init/1` and `c:call/2`. For example\nimplementation of middleware please look at `Spaceboy.Middleware.Logger` module.","ref":"Spaceboy.Middleware.html"},{"type":"callback","title":"Spaceboy.Middleware.call/2","doc":"","ref":"Spaceboy.Middleware.html#c:call/2"},{"type":"callback","title":"Spaceboy.Middleware.init/1","doc":"","ref":"Spaceboy.Middleware.html#c:init/1"},{"type":"function","title":"Spaceboy.Middleware.run/2","doc":"Run a series of Middlewares at runtime.\n\nIf any of the plugs halt, the remaining plugs are not invoked. If the given\nconnection was already halted, none of the plugs are invoked either.","ref":"Spaceboy.Middleware.html#run/2"},{"type":"module","title":"Spaceboy.Middleware.Logger","doc":"Example middleware which provides simple logging for processed request.\n\nUse in your `Spaceboy.Server` implementation as:\n\n    middleware Spaceboy.Middleware.Logger\n\nIt takes optional config `:log_level` which sets the level at which the logs\nare logged. By default it is `:debug` level.\n\n    middleware Spaceboy.Middleware.Logger, log_level: :info","ref":"Spaceboy.Middleware.Logger.html"},{"type":"module","title":"Spaceboy.Middleware.RequestId","doc":"A plug for generating a unique request id for each request.\n\nThe generated request id will be in the format\n\"uq8hs30oafhj5vve8ji5pmp7mtopc08f\".\n\nThe request id is added to the Logger metadata as `:request_id` and the conn\nstruct. To see the request id in your log output, configure your logger\nbackends to include the `:request_id` metadata:\n\n    config :logger, :console, metadata: [:request_id]\n\nIt is recommended to include this metadata configuration in your production\nconfiguration file.\n\nYou can also access the `request_id` programmatically by calling\n`Logger.metadata[:request_id]`.\n\nTo use this middleware, just plug it into the desired server:\n\n    middleware Spaceboy.Middleware.RequestId","ref":"Spaceboy.Middleware.RequestId.html"},{"type":"module","title":"Spaceboy.Middleware.Telemetry","doc":"A plug to instrument the server with `:telemetry` events.\n\nThis middleware is only defined if you manually install optional dependency\n`:telemetry`.\n\n      {:telemetry, \"~> 1.0\"},\n\nWhen plugged, the event prefix is a required option:\n\n    middleware Spaceboy.Middleware.Telemetry, event_prefix: [:my, :server]\n\nIn the example above, two events will be emitted:\n\n  * `[:my, :server, :start]` - emitted when the plug is invoked.\n    The event carries the `system_time` as measurement. The metadata\n    is the whole `Spaceboy.Conn` under the `:conn` key and any leftover\n    options given to the plug under `:options`.\n\n  * `[:my, :server, :stop]` - emitted right before the request is sent.\n    The event carries a single measurement, `:duration`,  which is the\n    monotonic time difference between the stop and start events.\n    It has the same metadata as the start event, except the connection\n    has been updated.\n\nNote this plug measures the time between its invocation until a response\nis sent. The `:stop` event is not guaranteed to be emitted in all error\ncases, so this middleware cannot be used as a Telemetry span.","ref":"Spaceboy.Middleware.Telemetry.html"},{"type":"module","title":"Time unit - Spaceboy.Middleware.Telemetry","doc":"The `:duration` measurements are presented in the `:native` time unit.\nYou can read more about it in the docs for `System.convert_time_unit/3`.","ref":"Spaceboy.Middleware.Telemetry.html#module-time-unit"},{"type":"module","title":"Spaceboy.PeerCert","doc":"Utility functions to ease the work with Peer Certificates","ref":"Spaceboy.PeerCert.html"},{"type":"type","title":"Spaceboy.PeerCert.peer_cert/0","doc":"","ref":"Spaceboy.PeerCert.html#t:peer_cert/0"},{"type":"type","title":"Spaceboy.PeerCert.rdn/0","doc":"","ref":"Spaceboy.PeerCert.html#t:rdn/0"},{"type":"function","title":"Spaceboy.PeerCert.rdn/1","doc":"Extract RDN Sequences from certificate","ref":"Spaceboy.PeerCert.html#rdn/1"},{"type":"module","title":"Spaceboy.Robots","doc":"Controller handling robots.txt file generation\n\nYou are not supposed to use it directly but with `Spaceboy.Router.robots/1`\nmacro which nicely wraps its functionality.","ref":"Spaceboy.Robots.html"},{"type":"function","title":"Spaceboy.Robots.render/2","doc":"Render /robots.txt file","ref":"Spaceboy.Robots.html#render/2"},{"type":"module","title":"Spaceboy.Static","doc":"Controller handling static files rendering\n\nYou are not supposed to use it directly but with `Spaceboy.Router.static/3`\nmacro which nicely wraps its functionality.","ref":"Spaceboy.Static.html"},{"type":"function","title":"Spaceboy.Static.render/2","doc":"Render appropriate content for the path","ref":"Spaceboy.Static.html#render/2"},{"type":"function","title":"Options - Spaceboy.Static.render/2","doc":"* `:root` - filesystem root path for static files\n  * `:prefix` - URL prefix for the static files\n  * `:ls_dir?` - list files for dirs which doesn't have \"index.gmi\" (default\n    `true`)\n  * `:mime` - can be `:guess` or static MIME type for all files (default\n    `\"text/gemini; charset=utf-8\"`)","ref":"Spaceboy.Static.html#render/2-options"},{"type":"module","title":"Spaceboy.Header","doc":"Struct representing Gemini header response.\n\nYou should not create headers directly - all supported headers has functions\nwith correct codes.","ref":"Spaceboy.Header.html"},{"type":"function","title":"Spaceboy.Header.bad_request/1","doc":"","ref":"Spaceboy.Header.html#bad_request/1"},{"type":"function","title":"Spaceboy.Header.certificate_not_authorized/1","doc":"","ref":"Spaceboy.Header.html#certificate_not_authorized/1"},{"type":"function","title":"Spaceboy.Header.certificate_not_valid/1","doc":"","ref":"Spaceboy.Header.html#certificate_not_valid/1"},{"type":"function","title":"Spaceboy.Header.cgi_error/1","doc":"","ref":"Spaceboy.Header.html#cgi_error/1"},{"type":"function","title":"Spaceboy.Header.client_certificate_required/1","doc":"","ref":"Spaceboy.Header.html#client_certificate_required/1"},{"type":"function","title":"Spaceboy.Header.format/1","doc":"Correctly format the response header","ref":"Spaceboy.Header.html#format/1"},{"type":"function","title":"Examples - Spaceboy.Header.format/1","doc":"iex> \"Test input\" |> Spaceboy.Header.input() |> Spaceboy.Header.format()\n    \"10 Test input\\r\\n\"\n\n    iex> Spaceboy.Header.success() |> Spaceboy.Header.format()\n    \"20 text/gemini; charset=utf-8\\r\\n\"","ref":"Spaceboy.Header.html#format/1-examples"},{"type":"function","title":"Spaceboy.Header.gone/1","doc":"","ref":"Spaceboy.Header.html#gone/1"},{"type":"function","title":"Spaceboy.Header.input/1","doc":"","ref":"Spaceboy.Header.html#input/1"},{"type":"macro","title":"Spaceboy.Header.is_error_code/1","doc":"","ref":"Spaceboy.Header.html#is_error_code/1"},{"type":"macro","title":"Spaceboy.Header.is_status_code/1","doc":"","ref":"Spaceboy.Header.html#is_status_code/1"},{"type":"function","title":"Spaceboy.Header.not_found/1","doc":"","ref":"Spaceboy.Header.html#not_found/1"},{"type":"function","title":"Spaceboy.Header.permanent_failure/1","doc":"","ref":"Spaceboy.Header.html#permanent_failure/1"},{"type":"function","title":"Spaceboy.Header.permanent_redirect/1","doc":"","ref":"Spaceboy.Header.html#permanent_redirect/1"},{"type":"function","title":"Spaceboy.Header.proxy_error/1","doc":"","ref":"Spaceboy.Header.html#proxy_error/1"},{"type":"function","title":"Spaceboy.Header.proxy_request_refused/1","doc":"","ref":"Spaceboy.Header.html#proxy_request_refused/1"},{"type":"function","title":"Spaceboy.Header.redirect/1","doc":"","ref":"Spaceboy.Header.html#redirect/1"},{"type":"function","title":"Spaceboy.Header.sensitive_input/1","doc":"","ref":"Spaceboy.Header.html#sensitive_input/1"},{"type":"function","title":"Spaceboy.Header.server_unavailable/1","doc":"","ref":"Spaceboy.Header.html#server_unavailable/1"},{"type":"function","title":"Spaceboy.Header.slow_down/1","doc":"","ref":"Spaceboy.Header.html#slow_down/1"},{"type":"function","title":"Spaceboy.Header.success/1","doc":"","ref":"Spaceboy.Header.html#success/1"},{"type":"type","title":"Spaceboy.Header.t/0","doc":"Struct representing Gemini header data","ref":"Spaceboy.Header.html#t:t/0"},{"type":"function","title":"Spaceboy.Header.temporary_failure/1","doc":"","ref":"Spaceboy.Header.html#temporary_failure/1"},{"type":"function","title":"Spaceboy.Header.temporary_redirect/1","doc":"","ref":"Spaceboy.Header.html#temporary_redirect/1"},{"type":"module","title":"Spaceboy.Specification","doc":"Check if the request received is according to specification.\n\nhttps://gitlab.com/gemini-specification/protocol/-/blob/master/specification.gmi","ref":"Spaceboy.Specification.html"},{"type":"function","title":"Spaceboy.Specification.check/2","doc":"Check the received data against Gemini specification","ref":"Spaceboy.Specification.html#check/2"},{"type":"function","title":"Examples - Spaceboy.Specification.check/2","doc":"iex> Spaceboy.Specification.check(\"gemini://localhost/\\r\\n\")\n    {:ok, %URI{authority: \"localhost\", host: \"localhost\", path: \"/\", scheme: \"gemini\"}}","ref":"Spaceboy.Specification.html#check/2-examples"},{"type":"exception","title":"Spaceboy.OutOfSpecError","doc":"Raised when attempted to do action which is not supported by Gemini specs","ref":"Spaceboy.OutOfSpecError.html"},{"type":"extras","title":"Overview","doc":"# Overview\n\nSpaceboy is a Gemini development framework written in Elixir. It aims to\nroughly equivalent to [Phoenix](https://hexdocs.pm/phoenix/) framework so the\ntransition from web to Gemini is as smooth as possible.","ref":"overview.html"},{"type":"extras","title":"Useful links - Overview","doc":"* [Gemini specification](https://gitlab.com/gemini-specification)\n* [Source Code](https://git.sr.ht/~sgiath/dotfiles)\n* [Issue Tracker](https://todo.sr.ht/~sgiath/spaceboy)","ref":"overview.html#useful-links"},{"type":"extras","title":"Installation","doc":"# Installation\n\nCheck example application in\n[`example/`](https://git.sr.ht/~sgiath/spaceboy/tree/master/item/example) folder\n\n* Add dependency\n* Create server\n* Create router\n* Create controller\n* Start server in Supervision tree\n* Generate certificate\n* (optional) add configuration","ref":"installation.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}